 # -*- coding:Utf-8 -*-
import es, os, ircbot, irclib, threading, repeat, cfglib

# Variables
config = cfglib.AddonCFG(es.getAddonPath("ircss") + "/ircss.cfg")
 
config.text("******************************")
config.text("  IRCSS SETTINGS")
config.text("******************************")
 
server  = config.cvar("server",  "Server adress(ip/nam)", "Your irc server")
port = config.cvar("port", 6667, "Server port")
channel = config.cvar("channel", "#channel", "Your channel")
botname = config.cvar("botname", "name", "The name of your Bot")
irclib.DEBUG = config.cvar("irclib.DEBUG", 0, "Print IRC informations ? (server to client) 1/0")
forcing  = config.cvar("forcing",  1, "If the bot is not able to connect the server, change this value to 1")
stream = config.cvar("stream", 0, "Stream game server messages on the channel 1 = on")
streamIRC = config.cvar("streamIRC", 0, "Steam messages from the irc channel on the game server. 1= on")
adminIRCSS = config.cvar("adminIRCSS", "pseudo~name@********.**.***.**", "Get your  mask and put it here")
config.write() 


esserver = None
player = None
lm = None

  # Thread
def start_bot():
    BotToList().start()
    
startbot = threading.Thread(None, start_bot, "ircss")

# Repeat
def debugbot():
    es.server.queuecmd('eventscripts_debug 0')
    
debug = repeat.create('debug', debugbot)

# ES
def load ():
    config.execute()
    startbot.start()
    if forcing == 1: debug.start(0.1, 0.1)
    es.msg("#multi", "#green ircss-v1#default by @liVier#lightgreen On !")
	   
def unload ():
    debug.stop()
    es.msg("#multi", "#green ircss-v1#default by @liVier#lightgreen Off!")
    print('Last message is: %s' %lm)

def player_say(event_var):
    global player
    player = event_var["es_username"]
    global lm
    lm = event_var["text"]
    if stream == 1: 
	    esserver.privmsg(channel,'<%s>%s' % (player,lm))
    
    sendmsg = event_var["text"].split()
    if sendmsg[0] == '!irc' and len(sendmsg) > 1:
        selec = ''.join(text+' ' for text in sendmsg[1:])
        esserver.privmsg(channel,'IG<%s>%s' % (player,selec))
        
	     
	    
# IRCSSbot	
class BotToList(ircbot.SingleServerIRCBot):
	
	def __init__(self):
	    ircbot.SingleServerIRCBot.__init__(self, [('%s' % server, port)], '%s' % botname, 'Chatbox streaming')
	    

	def on_welcome(self, serv, ev):
	        global esserver
	        esserver = serv
	        serv.join(channel)
			
    
	def on_pubmsg(self, serv, ev):
            adminES = ev.source()	
            ircfrom = irclib.nm_to_n(ev.source())
            message = ev.arguments()[0]
            if streamIRC == 1: 
			   es.msg("#multi", "#green %s#lightgreen <%s>#default %s" % (channel,ircfrom,message))
            if message[0:5] == '!send' and len(message) > 6:
		       selecIRC = ''.join(text+'' for text in message[6:])
		       es.msg("#multi", "#green %s#lightgreen <%s>#default %s" % (channel,ircfrom,selecIRC))
            if message[0:7] == '!eskick' and len(message) >8 and adminES == adminIRCSS:
			   userid = es.getuserid(''.join(text+'' for text in message[8:]))
			   es.server.queuecmd('kickid %s' % userid)
			   
